$(function () {

    const $login = $('#login');
    const $pass = $('#password');
    const $signInButton = $('#signin_b');
    const $signUpButton = $('#signup_b');
    const $loginOpenID = $('#loginopenid');
    const $signInOpenIDButton = $('#signopenidin_b');

    const tryToAuthorizeGrade = function () {
        const login = $login.val();
        const pass = $pass.val();

        Auth.signIn(login, pass)
            .fail(_ => Popup.error('Неверный логин и/или пароль!'))
            .done(() => {
                $signInButton.val('Всё отлично!');
                window.location.replace(g_URLdir);
            })
    };
    $signInButton.click(tryToAuthorizeGrade);

    const tryToAuthorizeByOpenID = function () {
        const login = $loginOpenID.val();
        // userRole для http://gitlab.mmcs.sfedu.ru/it-lab/grade/issues/248
        const userRole = $('#user_role').val();
        if (! login.trim()) {
            alert('Необходимо ввести логин ЮФУ')
            return;
        }
        window.location = g_URLdir + "handler/sign/openidlogin?loginopenid=" + login + "&user_role=" + userRole;
    };
    $signInOpenIDButton.click(tryToAuthorizeByOpenID);

    // todo: animation
    Auth.onAllow = () => $signInButton.removeAttr('disabled');
    Auth.onDeprecate = () => $signInButton.attr('disabled', 'disabled');


    $('#remind').click(function () {
        $.postJSON(g_URLdir + 'handler/sign/remindPassword', { 'email': $('#email').val() })
            .fail(err => EventInspector.error(err.responseText))
            .done(_ => {
                $('#remind').val('Проверьте почту!');
                window.location.replace(g_URLdir);
            })
    });

    $('#changepass_b').click(function() {
        $.post(g_URLdir + 'handler/sign/changePassword', {
                'password': $('#password').val(),
                'confirm_password': $('#confirm_password').val(),
                'token': $('#token').val()
            },
            function(data)
            {
                data = $.parseJSON(data);
                if(data.success === true)
                {
                    $('#changepass_b').val('Пароль успешно изменен!');
                    window.location.replace(g_URLdir);
                }
                else
                {
                    $('input').each(function(){
                        $(this).removeClass('wrong');
                    });
                    $('#errors').html('<ul>');
                    $.each(data.errors, function(i){
                        EventInspector.error(data.errors[i]);
                        $('#' + i).addClass('wrong');
                    });
                }
            });
    });

    const tryToRegisterGrade = function () {
        $.postJSON(g_URLdir + 'handler/sign/up', {
            'activation_code':  $('#activation_code').val(),
            'login':            $('#login').val(),
            'password':         $('#password').val(),
            'confirm_password': $('#confirm_password').val(),
            'email':            $('#email').val(),
            'confirm_email':    $('#confirm_email').val()
        }).done(_ => {
            $signUpButton.val('Всё отлично!');
            window.location.replace(g_URLdir);
        }).fail(err => Popup.error(err.responseText));
    };
    $signUpButton.click(tryToRegisterGrade);

    $(document).keypress(function (event) {
        if (event.keyCode == 13) {
            if ($login.is(':focus')) {
                $pass.focus();
            } else if ($pass.is(':focus')) {
                tryToAuthorizeGrade();
            } else if ($loginOpenID.is(':focus')) {
                tryToAuthorizeByOpenID();
            }
        }
    });

    const loginField = document.querySelector('[id="login"]');
    if (loginField) {
        loginField.addEventListener('keypress', function (event) {
            var key = event.keyCode;
            if (key === 32) {
                event.preventDefault();
            }
        });
    }

    const emailField = document.querySelector('[id="email"]');
    if (emailField) {
        emailField.addEventListener('keypress', function (event) {
            var key = event.keyCode;
            if (key === 32) {
                event.preventDefault();
            }
        });
    }

    // для http://gitlab.mmcs.sfedu.ru/it-lab/grade/issues/248
    // взято целиком из https://www.w3schools.com/howto/howto_js_collapsible.asp
    // (как сделать сворачиваемый элемент)
    var coll = document.getElementsByClassName("collapsible");
    var i;

    for (i = 0; i < coll.length; i++) {
        coll[i].addEventListener("click", function() {
            this.classList.toggle("active");
            var content = this.nextElementSibling;
            if (content.style.display === "block") {
                content.style.display = "none";
            } else {
                content.style.display = "block";
            }
        });
    }
    
});
